<style scoped>

</style>

<template>
    <div :style="{ width: width + 'px', height: getMapHeight + 'px' }">
        <svg xmlns="http://www.w3.org/2000/svg"
             xmlns:xlink="http://www.w3.org/1999/xlink"
             :width="width" :height="getMapHeight" viewBox="0 0 201 97">
            <title :id="svgName" lang="en" v-html="svgName"></title>
            <g :fill="iconColor">
                <slot />
            </g>
        </svg>
    </div>
</template>

<script>
    export default {
        name: "WorldWrapper",

        props: {
            svgName: { // Name to assign to the svg that draws the world map
                type: String,
                default: 'World Map'
            },
            width: { // The width to assign to this world map
                type: [Number],
                default: 600
            },
            iconColor: { // Default color to use for each point that draws the world
                type: String,
                default: '#333'
            }
        },

        computed: {
            /**
             * Get the height to assign to the svg world map. The height depends on the
             * map width and is related based on a 320/600 ratio.
             *
             * I didn't simplify the 320/600 to 8/15 in order to remind myself that this
             * ratio is based on the original svg map dimensions
             */
            getMapHeight: function () {
                return Math.ceil((320 * this.width) / 600);
            }
        }
    }
</script>